from bpcms.models import Document, Folder
import operator

def content_menu(request):
    items = Document.objects.filter(folder__isnull=True, islive__exact=True)
    menu_items = []
    for item in items:
        if item.slug != 'index':
            menu_items.append(
                {
                    'title': item.title,
                    'url': item.get_basic_url(),
                }
            )
    folders = Folder.objects.filter(parent__isnull=True)
    for folder in folders:
        try:
            items = Document.objects.filter(folder__exact=folder, islive__exact=True, slug__exact='index')
            item = items[0]
            menu_items.append(
                {
                    'title': item.title,
                    'url': folder.get_basic_url(),
                }
            )
        except:
            pass

    menu_items.sort(cmp=lambda x,y: cmp(x['title'].lower(), y['title'].lower()))

    return {
        'content_menu': menu_items,
    }
